c----------------------------------------------------------------------c
c                                                                      c
c    1D Trasient Neutron diffusion with sources                        c
c    Program set up for teaching purposes only                         c
c    W. Ambrosini - Universit di Pisa                                 c
c                                                                      c
c----------------------------------------------------------------------c
      program nonsta
      implicit double precision (a-h,o-z)
      character*80 riga
c
      parameter (m = 50)
      dimension phi(0:m+1),x(0:m+1),xsour(10),sour(10),isour(10)
      dimension a(m),b(m),c(m),d(m),v(m),alef(m),bet(m)
c
      open (unit=5,file='nonsta.dat')
      open (unit=6,file='nonsta.txt')
c
      read (5,100) riga
      read (5,*) aleng,diff,sigma,vel,n
c
      read (5,100) riga
      read (5,*) dt,tend,alpha
c
      read (5,100) riga
      read (5,*) nsour
c
      read (5,100) riga
c
      do 5 is = 1,nsour
      read (5,*) xsour(is),sour(is)
    5 continue
c
      read (5,100) riga
      read (5,*) xbar,sigbar
c
      np1 = n + 1
      dx = aleng / dfloat (np1)
      cmpalp = 1.d00 - alpha
      veldt = vel * dt
      sigdt = sigma * dt
      dx2 = dx * dx
c
      phi(0) = 0.d00
      phi(np1) = 0.d00
      x(0) = 0.d00
      x(np1) = aleng
c
      do 10 i = 1,n
c
      phi(i) = 1.d00
      x(i) = dx * dfloat(i)
c
      halfdx = 0.5d00 * dx
c
	  do j = 1,nsour
        if(dabs(xsour(j)-x(i)).le.halfdx) isour(j) = i
	  enddo
c
        if(dabs(xbar-x(i)).le.halfdx) ibar = i
c
      auxsig = 0.d00
	if(i.eq.ibar) auxsig = sigbar
c
      a(i) = - veldt * alpha * diff / dx2
      b(i) = 1.d00 + veldt * alpha * ( 2.d00 * diff / dx2 
     &                  + sigma + auxsig )
      c(i) = a(i)
c
   10 continue
c
c   Loop on time advancement
c
      time = 0.d00
      do 50 it = 1,5000000
      time = time + dt
c
      do 20 i = 1,n
      im1 = i - 1
      ip1 = i + 1
      d2phi = phi(ip1) - 2.d00 * phi(i) + phi(im1)
C
      auxsig = 0.d00
	if(i.eq.ibar) auxsig = sigbar
      d(i) = phi(i) + veldt * cmpalp * ( diff * d2phi / dx2
     &                      - ( sigma + auxsig ) * phi(i) )
c	 
       do j = 1,nsour
	 if(i.eq.isour(j)) d(i) = d(i) + veldt * sour(j)
       enddo
c
   20 continue
c
      call tdma (a,b,c,d,v,alef,bet,n,m)
c
      phimax = 0.d00
      do 30 i = 0,np1
      if((i.ne.0).and.(i.ne.np1)) phi(i) = v(i)
      write(6,110) time,x(i),phi(i)
      if(phimax.lt.dabs(phi(i))) phimax = phi(i)
   30 continue
      if((time.ge.tend).or.(phimax.gt.10.d00)) goto 60
c
   50 continue
   60 continue
c
      stop
  100 format(a80)
  110 format(3(1x,e14.7))
      end
c----------------------------------------------------------------------c
c                                                                      c
c   TDMA Algorithm                                                     c
c                                                                      c
c----------------------------------------------------------------------c
      subroutine tdma (a,b,c,d,v,alef,bet,n,ld)
      implicit double precision (a-h,o-z)
      dimension a(ld),b(ld),c(ld),d(ld),v(ld),alef(ld),bet(ld)
      ub=1.d00/b(1)
      alef(1)=c(1)*ub
      bet(1)=d(1)*ub
      do 10 i=2,n
      l=i-1
      qz=b(i)-a(i)*alef(l)
      uqz=1.d00/qz
      alef(i)=c(i)*uqz
   10 bet(i)=(d(i)-a(i)*bet(l))*uqz
      nm1=n-1
      v(n)=bet(n)
      do 20 i=1,nm1
      ii=n-i
      l=ii+1
   20 v(ii)=bet(ii)-alef(ii)*v(l)
      return
      end
